

//Generated by StarUML(tm) Java Add-In

//@ Project : Untitled
//@ File Name : Communication.java
//@ Date : 16/04/2007
//@ Author : 





package bootstrapP;

import java.io.Serializable;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.Iterator;

import common.*;
import common.interfaces.exceptions.*;


/** The class that contains the methods needed for communicating with other servers and servlets.
 * @author Marco Cornolti
 *
 */
public class Communication extends UnicastRemoteObject implements common.interfaces.BSForMSInterface, common.interfaces.BSForServletInterface, Serializable{

	private static final long serialVersionUID = 1L;

	/**The constructor.
	 * @throws RemoteException if a remote exception occurred.
	 */
	protected Communication() throws RemoteException {
		super();
	}
	
	/* (non-Javadoc)
	 * @see common.interfaces.BSForMSInterface#getMS(common.User)
	 */
	public MessageServer getMS(User user) throws UserNotExistsException {
		RegisteredUser reg = UsersDatabase.getUser(user);
		if (reg==null) throw new UserNotExistsException();
		return reg.getMS();
	}

	/* (non-Javadoc)
	 * @see common.interfaces.BSForServletInterface#register(java.lang.String, java.lang.String)
	 */
	public void register(String nickCase, String pw) throws GenericErrorException, AssignationNotAcceptedException{
		String nick = nickCase.toLowerCase();
		Iterator<ManagedMessageServer> msi = MessageServersDatabase.getMSIterator();
		User usr = new User(nick,null,0,false,false);
		if (UsersDatabase.getUser(nick)!=null) throw new AssignationNotAcceptedException();
		while (msi.hasNext()){
			ManagedMessageServer ms = msi.next();
			try{
				ms.safeInt.assign(ms.getPw(), usr, pw);
			} catch (RemoteException e){
				continue;
			} catch (BlockedException e){
				continue;
			} catch (WrongPasswordException e){
				HumanListener.currentInt.showWrongMSPassword(ms.getIP().getCanonicalHostName(), ms.getUDPPort(), ms.getRMIPort());
				continue;
			}
			UsersDatabase.registerUser(pw, nick, ms);
			return;
		}
		throw new GenericErrorException();
	}

	/* (non-Javadoc)
	 * @see common.interfaces.BSForServletInterface#deleteUser(common.User, java.lang.String)
	 */
	public void deleteUser(common.User user, String pw) throws UserNotExistsException, WrongPasswordException, GenericErrorException,BlockedException {
		RegisteredUser reg = UsersDatabase.getUser(user);
		if (reg==null) throw new UserNotExistsException();
		if (!reg.checkPassword(pw)) throw new WrongPasswordException();
		ManagedMessageServer ms=null;
		try {
			ms = reg.getMS();
			ms.safeInt.deleteUserAdmin(user, reg.getMS().getPw());
			UsersDatabase.deleteUser(reg.getNick());
			return;
		} catch (RemoteException e){
			throw new GenericErrorException();
		} catch (WrongPasswordException e) {
			throw new GenericErrorException();
		} catch (BlockedException e) {
			throw new BlockedException();
		} catch (UserNotManagedException e) {
			throw new GenericErrorException();
		}

	}
}
