//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : HumanInterface.java
//  @ Date : 18/04/2007
//  @ Author : 
//
//



package bootstrapP;

/**The interface that represents an interaction with a human (the server admin).
 * @author Marco Cornolti
 *
 */
public interface HumanInterface {
	/**Gets the next command to execute from the interface.
	 * @return the command to execute.
	 */
	public Command getCommand();
	
	/**
	 * Initialize the interface.
	 */
	public void initialize();

	/** Called when a MS load is received.
	 * @param hostname the sender hostname.
	 * @param freeMem the free memory.
	 * @param fwdMess the forwarded messages.
	 */
	public void showReceivedLoad(String hostname, int freeMem, int fwdMess);

	/** Called when a MS cannot be removed.
	 * @param id1 the id of the MS that could not be removed.
	 */
	public void showMSNotRemoved(int id1);

	/** Called when a MS has been removed.
	 * @param id1 the id of the removed message server.
	 */
	public void showMSRemoved(int id1);

	/** Called when a user could not be moved.
	 * @param nick the user nickname.
	 */
	public void showUserNotMoved(String nick);

	/** Called when a user has been successfully moved.
	 * @param nick the user nickname.
	 */
	public void showUserMoved(String nick);

	/**Called when a user could not be deleted.
	 * @param nick the user nickname
	 */
	public void showUserNotDeleted(String nick);

	/**Called when a user was successfully deleted.
	 * @param nick the user nickname
	 */
	public void showUserDeleted(String nick);

	/**Called when a user does not exist.
	 * @param nick the user nickname
	 */
	public void showUserNotExists(String nick);

	/**Called when a Message Server could not be contacted.
	 * @param hostname the MS hostname.
	 * @param udpPort the MS UDP port.
	 * @param rmiPort the MS RMI port.
	 */
	public void showCouldNotContactMS(String hostname, int udpPort, int rmiPort);

	/**
	 * Called when an UDP problem occurred.
	 */
	public void showUDPProblem();

	/**Called when some statistics has to be shown. 
	 * @param upTime the local server uptime.
	 * @param usersNumber the number of currently registered users.
	 * @param MSnumber the number of registered message servers.
	 */
	public void showStatistics(long upTime, int usersNumber, int MSnumber);

	/**Called when some global statistics must be shown.
	 * @param mss total number of Message Servers.
	 * @param minFreeMem the minimum free memory in a single server.
	 * @param minFreeMemI the id of the server with the minimum free memory.
	 * @param canonicalHostName the hostname of the server with the minimum free memory.
	 * @param maxFreeMem the maximum free memory in a single server.
	 * @param maxFreeMemI the id of the server with the maximum free memory. 
	 * @param canonicalHostName2 the hostname of the server with the maximum free memory.
	 * @param minManUsers the minimum managed users in a single server.
	 * @param minManUsersI the id of the server with the minimum managed users.
	 * @param canonicalHostName3 the hostname of the server with the minimum managed users.
	 * @param maxManUsers the maximum managed users in a single server.
	 * @param maxManUsersI the id of the server with the maximum managed users.
	 * @param canonicalHostName4 the hostname of the server with the maximum managed users.
	 * @param fwMsgs the totally forwarded messages.
	 * @param onlineUsers the estimate online users.
	 * @param queuedMsgs the number of messages stored in the message servers queues. 
	 */
	public void showGlobalMSStats(int mss, long minFreeMem, int minFreeMemI, String canonicalHostName, long maxFreeMem, int maxFreeMemI, String canonicalHostName2, int minManUsers, int minManUsersI, String canonicalHostName3, int maxManUsers, int maxManUsersI, String canonicalHostName4, long fwMsgs, long onlineUsers, long queuedMsgs);

	/**Called when a single server statistics must be shown.
	 * @param id the server id.
	 * @param canonicalHostName the server hostname.
	 * @param RMIport the server RMI port.
	 * @param UDPport the server UDP port.
	 * @param cacheEntries the cache entries.
	 * @param freeMem the free memory.
	 * @param load the load.
	 * @param forwardedMessagesMinute the number of messages forwarded in the last minute.
	 * @param forwardedMessagesHour the number of messages forwarded in the last hour.
	 * @param forwardedMessages24Hours the number of messages forwarded in the last day.
	 * @param forwardedMessages144Hours the number of messages forwarded in the last week.
	 * @param managedUsers the number of managed users.
	 * @param onlineManagedUsers the number of online managed users.
	 * @param queuedMessageNumber the number of queued messages.
	 */
	public void showSingleMSStats(int id, String canonicalHostName, int RMIport, int UDPport, int cacheEntries, long freeMem, long load, int forwardedMessagesMinute, int forwardedMessagesHour, int forwardedMessages24Hours, int forwardedMessages144Hours, int managedUsers, int onlineManagedUsers, int queuedMessageNumber);

	/**
	 * Called when a load could not be received.
	 */
	public void showReceivedLoadFailed();

	/** Called when a MS is added.
	 * @param canonicalHostName the ms hostname.
	 * @param udpPort the UDP port.
	 * @param rmiPort the RMI port.
	 */
	public void showMSAdded(String canonicalHostName, int udpPort, int rmiPort);

	/**Called when a Message server password is wrong.
	 * @param canonicalHostName the MS hostname.
	 * @param udpPort the MS UDP port.
	 * @param rmiPort the MS RMI port.
	 */
	public void showWrongMSPassword(String canonicalHostName, int udpPort, int rmiPort);

	/**Called when a MS id is not correct.
	 * @param id1 the wrong id.
	 */
	public void showWrongMSId(int id1);

	/**Shows a list of users managed by a message server.
	 * @param id1 the ms id.
	 * @param userStr the users string representation.
	 */
	public void showUserList(int id1, String userStr);

	/**Called when a Message server password is wrong.
	 * @param id1 the MS id.
	 */
	public void showWrongMSPassword(int id1);

	/**Called when a communication problem with a MS occurred.
	 * @param id1 the MS id.
	 */
	public void showMSCommunicationProblem(int id1);

	/**Called when a presence test for a MS is done correctly.
	 * @param id1 the MS id
	 */
	public void showTestPresenceDone(int id1);

	/**Called when a presence test for a MS failed.
	 * @param id1 the MS id
	 */
	public void showTestPresenceFailed(int id1);

	/**Called when a MS Shutdown is done correctly.
	 * @param id1 the MS id
	 */
	public void showMSShutdownDone(int id1);

	/**Called when a MS is blocked.
	 * @param id1 the MS id.
	 */
	public void showMSBlocked(int id1);

	/**Called when a MS is not blocked.
	 * @param id1 the MS id.
	 */
	public void showMSUnblocked(int id1);

	/** Called when an udp packet from an unknown Message server is received.
	 * @param hostAddress the sender hostname.
	 * @param port the sender UDP port.
	 */
	public void showMSUnknown(String hostAddress, int port);

	/**Called when a user is not managed by a Message server.
	 * @param managerMSi the MS id.
	 * @param user the user nickname.
	 */
	public void showUserNotManaged(int managerMSi, String user);

	/**Called when a MS does not accept a user assignation.
	 * @param ms1i the MS id.
	 * @param nick the user nickname.
	 */
	public void showMSUserNotAccepted(int ms1i, String nick);

	/**Called when a generic error occurred in the message server.
	 * @param ms1i the message server ID.
	 */
	public void showMSGenericError(int ms1i);

	/**Called when a MS cannot shutdown because some users are still assigned to it.
	 * @param id1 the ms id.
	 */
	public void showMSShutdownFailedUsersPresent(int id1);
	
	/**Called when a MS cannot shutdown because it is not blocked.
	 * @param id1 the ms id.
	 */
	public void showCouldNotShutdownUnblockedMS(int id1);

	/**Called when some given data are not right.
	 * @param hostname the given hostname.
	 * @param port the given RMI port.
	 * @param port2 the given UDP port.
	 */
	public void showIllegalArgument(String hostname, int port, int port2);

	/**Called when a backup problem occurred and a MS could not be saved.
	 * @param hostname the MS hostname.
	 * @param RMIport the MS RMI port.
	 * @param UDPport the Ms UDP port.
	 */
	public void showCouldNotBackupMS(String hostname, int RMIport, int UDPport);
	
	/**Called when a backup problem occurred and a User could not be saved.
	 * @param nickname the user nickname.
	 */
	public void showCouldNotBackupUser(String nickname);

	/**Called when a backup problem occurred and a MS could not be removed.
	 * @param hostName the MS hostname
	 * @param RMIport the MS RMI port.
	 * @param UDPport the MS UDP port.
	 */
	public void showCouldNotRemoveBackuppedMS(String hostName, int RMIport, int UDPport);

	/**Called when a backup problem occurred and a User could not be removed.
	 * @param nick the user nickname.
	 */
	public void showCouldNotRemoveBackuppedUser(String nick);

	/**Called when a file backupper starts.
	 * @param filename the name of the file the main backupper is working on.
	 */
	public void showBackupFileStart(String filename);

	/**Called when the main backupper ends.
	 */
	public void showBackupDone();

	/**Called when a backupper unit starts.
	 */
	public void showBackupStart();

	/**Called when a backupper unit failed to backup.
	 */
	public void showBackupFailed();

	/**Called when somebody is trying to move a user from a server to its server.
	 * @param nick the user nickname.
	 */
	public void showUserMoveSameDest(String nick);

	/**Called when the admin tried to add an already added message server.
	 */
	public void showMSAlreadyInseted();
	
	/**Called when the interface must be terminated.
	 */
	public void destroy();
	    
		
}
