//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : MessageServer.java
//  @ Date : 16/04/2007
//  @ Author : 
//
//



package bootstrapP;

import java.net.*;
import java.rmi.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**A representation of a Message Server managed by the Bootstrap server.
 * @author Marco Cornolti
 */
public class ManagedMessageServer extends common.MessageServer implements java.lang.Comparable<ManagedMessageServer> {
    private static final long serialVersionUID = 1L;
	private int load=0;
    private int UDPPort=0;
    private String password;
    public SafeMSForBSInterface safeInt;
    
    /**
     * @param ip the MS IP address
     * @param RMIPort the MS RMI port.
     * @param UDPPort the MS UDP port.
     * @param password the MS password.
     * @throws RemoteException if the server could not be reached.
     */
    public ManagedMessageServer(InetAddress ip, int RMIPort, int UDPPort, String password) throws RemoteException {
        super(ip, RMIPort);
        this.UDPPort=UDPPort;
        this.password=password;
        this.safeInt=new SafeMSForBSInterface(ip,RMIPort);
    }
    
    /**
     * @return the MS password.
     */
    public String getPw(){
        return this.password;
    }
    /**
     * @return the MS UDP port.
     */
    public int getUDPPort(){
        return this.UDPPort;
    }
    /**
     * @return the MS RMI port
     */
    public int getRMIPort(){
        return this.getPort();
    }
    
    /**
     * @return the current MS load (higher values mean higher load).
     */
    public int getLoad(){
        return this.load;
    }
    
    /**
     * Calculate and sets the load of a server from a received string.
     * @param dataS the string containing the data of the server load.
     */
    public void refreshLoad(String dataS){
		Pattern p = Pattern.compile("\\D*(\\d*)\\D*(\\d*)\\D*");
    	Matcher m = p.matcher(dataS);
		int freeMem=0, fwdMess=0;
    	try{
    		if (!m.find()) throw new NumberFormatException();
    		freeMem=Integer.parseInt(m.group(1));
    		fwdMess=Integer.parseInt(m.group(2)); 		
    		HumanListener.currentInt.showReceivedLoad(this.getIP().getCanonicalHostName(),freeMem,fwdMess);
    	} catch (NumberFormatException e){
    		HumanListener.currentInt.showReceivedLoadFailed();
    	}	
    	if (freeMem<1000)
    		load=0;
    	else
    		load=fwdMess+freeMem/1000;
    	MessageServersDatabase.reorder();
    }

    /** Compares the load of two message servers
     * @param ms the managed message server to compare to. 
     * @return >0 if this server is more loaded than the given one, 0 if the servers' loads are the same, <0 otherwise. 
     */
    public int compareTo(ManagedMessageServer ms) {
        return this.load - ms.load;
    }
    
    /**Checks if a message server is equal to another, witch means that it tests the RMI ports, UDP ports, IP addresses. 
     * @param ms the ms to check this one againts.
     * @return true if the two message servers are the same.
     */
    public boolean equals(ManagedMessageServer ms){
    	if (ms==null) return false;
    	return ms.UDPPort==this.UDPPort && ms.getIP().equals(this.getIP()) && this.getRMIPort()==ms.getRMIPort();
    }
    
}
