//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : BSForServletInterface.java
//  @ Date : 19/03/2007
//  @ Author : 
//
//



package common.interfaces;

import java.rmi.Remote;
import java.rmi.RemoteException;

import common.interfaces.exceptions.AssignationNotAcceptedException;
import common.interfaces.exceptions.BlockedException;
import common.interfaces.exceptions.GenericErrorException;
import common.interfaces.exceptions.UserNotExistsException;
import common.interfaces.exceptions.WrongPasswordException;


/**
 * This interface contains the method needed by a Gossip Servlet that the Bootstrap exported object must provide.
 * @author Marco Cornolti and Alessandro Franchini
 */
public interface BSForServletInterface extends Remote {
	/**Returns the message server of a user given by argument.
	 * @param user the user (only the nickname is considered).
	 * @return the user's message server.
	 * @throws RemoteException if a communication problem occurs.
	 * @throws UserNotExistsException if the user does not exist.
	 */
	public abstract common.MessageServer getMS(common.User user) throws RemoteException, UserNotExistsException;
	/**Creates an account for a new user.
	 * @param nick The new user nickname (case insensitive).
	 * @param pw The new user password.
	 * @throws GenericErrorException if there are no message server available for the assignation.
	 * @throws AssignationNotAccepted if another user with the same nickname already exists. 
	 * @throws RemoteException if a communication problem occurs.
	 */
	public abstract void register(String nick, String pw) throws RemoteException, GenericErrorException, AssignationNotAcceptedException;
    /**Deletes an account of a user (this method is used by the user itself).
     * @param user the user to delete
     * @param pw the user's password
     * @throws BlockedException if the user is currently blocked by the administrator.
     * @throws GenericErrorException if some error occurred and the user was not deleted (i.e. MS not reachable).
     * @throws WrongPasswordException if the user password is not right.
     * @throws UserNotExistsException if the user nickname does not exist. 
     */
    public abstract void deleteUser(common.User user, String pw) throws RemoteException, UserNotExistsException, WrongPasswordException, GenericErrorException, BlockedException;
}
