//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : Command.java
//  @ Date : 19/03/2007
//  @ Author : 
//
//



package messageServerP;


/**A command given by the administrator through the Human interface. 
 * @author Marco Cornolti
 */
public class Command {
	private int type;
	private String str=null;
    
	/**The constructor for a command with no arguments.
	 * @param type the command type.
	 */
	private Command(int type){
        this.type=type;
    }
	
	/**The constructor for a command with one string as argument.
	 * @param type the command type.
	 * @param str the string argument
	 */
	private Command(int type, String str){
        this.str=str;
    }
    
    /**
     * @return true if the command type is "print user statistics"
     */
    public boolean isPrintUsersStatistics() {
        return type==1;
    }
    
    /**
     * @return true if the command type is "print load statistics"
     */
    public boolean isPrintLoadStatistics() {
        return type==2;
    }
    
    /**
     * @return true if the command type is "shutdown"
     */
    public boolean isShutdown() {
        return type==3;
    }
    
    /**
     * @return true if the command type is "change interface to gui"
     */
    public boolean isChangeInterfaceToGUI() {
        return type==4;
    }
    
    /**
     * @return true if the command type is "change interface to textual"
     */
    public boolean isChangeInterfaceToText() {
        return type==5;
    }
    
    /**
     * @return true if the command type is "backup"
     */
    public boolean isBackup() {
        return type==6;
    }
    
    /**"print user statistics" command constructor.
     * @return a command of type "print user statistics"
     */
    public static Command makePrintUsersStatistics() {
        return new Command(1);
    }
    
    /**"print load statistics" command constructor.
     * @return a command of type "print load statistics"
     */
    public static Command makePrintLoadStatistics() {
        return new Command(2);
    }
    
    /**"shutdown" command constructor.
     * @return a command of type "shutdown"
     */
    public static Command makeShutdown() {
        return new Command(3);
    }
    
    /**"change interface to gui" command constructor.
     * @return a command of type "change interface to gui"
     */
    public static Command makeChangeInterfaceToGUI() {
        return new Command(4);
    }
    
    /**"change interface to textual" command constructor.
     * @return a command of type "change interface to textual"
     */
    public static Command makeChangeInterfaceToText() {
        return new Command(5);
    }

    /**"backup" command constructor.
     * @param filename the file name to backup to.
     * @return a command of type "backup"
     */
    public static Command makeBackup(String filename) {
        return new Command(6,filename);
    }
    
    
    /**
     * @return the command file name (for commands of type "backup")
     */
    public String getFilename(){
    	return this.str;
    }

}
