//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : HumanInterface.java
//  @ Date : 19/03/2007
//  @ Author : 
//
//



package messageServerP;

import common.Statistics;
import common.User;


/**The interface for a human administrator, containing all the methods to show messages, warnings or problems and receive commands.
 * @author Marco Cornolti
 */
public interface HumanInterface {
	/**@return the command got from the interface.
	 */
	public abstract Command getCommand();
    /**Initializes the interface.
     */
    public abstract void initialize();
    /**Destroys the interface.
     */
    public abstract void destroy();
    
    /**
     * Called when a presence test to this message server has been done.
     */
    public abstract void showTestPresence();
    
    /**Called when a user deletion by the administrator has been requested.
     * @param nick the user nickname
     */
    public abstract void showAdminDeletionRequest(String nick);
    /**Called when a user deletion by the administrator has been done.
     * @param nick the user nickname
     */
    public abstract void showAdminDeletionDone(String nick);
    
    /**Called when a user moving to this message server has been requested.
     * @param nick the user nickname.
     * @param messageServer the message server hostnae.
     */
    public abstract void showMoveRequest(String nick, String messageServer);
    /**Called when a user moving to this message server has been done.
     * @param nick the user nickname.
     * @param messageServer the message server hostnae.
     */
    public abstract void showMoveDone(String nick, String messageServer);
    
    /**
     * Called when the statistics of this MS has been requested. 
     */
    public abstract void showStatsRequest();
    
    /**Called when a new user assignation has been requested.
     * @param nick the user nickname.
     */
    public abstract void showAssignationRequest(String nick);
    /**Called when a new user assignation has been done.
     * @param nick the user nickname.
     */
    public abstract void showAssignationDone(String nick);
    
    /**Called when the list of users managed by this message server has been requested.
     */
    public abstract void showUsersListRequest();
   
    /**Called when the list of users managed by this message server has been done.
     */
    public abstract void showUsersListDone();
    
    /**Called when a user requested to add a user to its friend list.
     * @param user the calling user nickname.
     * @param userToAdd the user to add nickname.
     */
    public abstract void showAddToFriendRequest(String user, String userToAdd);
    /**Called when a user successfullt added a user to its friend list.
     * @param user the calling user nickname.
     * @param userToAdd the user to add nickname.
     */
    public abstract void showAddToFriendDone(String user, String userToAdd);
    
    /**Called when a user requests to download its message queue.
     * @param nick the user nickname.
     */
    public abstract void showDownloadRequest(String nick);
    /**Called when a user successfully downloaded its message queue.
     * @param nick the user nickname.
     */
    public abstract void showDownloadDone(String nick);

    
    /**Called when a user requests to change its status.
     * @param nick the user nickname.
     * @param state true if the new status is on-line, false if the new status is off-line.
     */
    public abstract void showSetStatusRequest(String nick, boolean state);
    /**Called when user successfully changed its status.
     * @param nick the user nickname.
     * @param state true if the new status is on-line, false if the new status is off-line.
     */
    public abstract void showSetStatusDone(String nick, boolean state);
    
    /**Called when a message forwarding has been requested.
     * @param from the sender of the message.
     * @param to the recipient of the message.
     * @param length the message length.
     */
    public abstract void showForwardRequest(String from, String to, int length);
    /**Called when a message forwarding has been done and the user is locally managed.
     * @param from the sender of the message.
     * @param to the recipient of the message.
     * @param length the message length.
     */
    public abstract void showForwardLocalDone(String from, String to, int length);
    /**Called when a message forwarding has been sent throught the cache.
     * @param from the sender of the message.
     * @param to the recipient of the message.
     * @param length the message length.
     */
    public abstract void showForwardCacheDone(String from, String to, int length);
    /**Called when a message forwarding was not allowed by the recipient message server.
     * @param from the sender of the message.
     * @param to the recipient of the message.
     * @param length the message length.
     */
    public abstract void showForwardNotAllowed(String from, String to, int length);
    /**Called when a message forwarding has been done and the user is managed by a remote message server.
     * @param from the sender of the message.
     * @param to the recipient of the message.
     * @param length the message length.
     */
    public abstract void showForwardDone(String from, String to, int length);
    
    /**Called when a user successfully obtained its contact list.
     * @param user the user nickname.
     */
    public abstract void showContactListDone(String user);
    /**Called when a user requests its contact list.
     * @param user the user nickname.
     */
    public abstract void showContactListRequest(String user);
    
    /**Called when a user successfully changed its password.
     * @param nick the user nickname.
     */
    public abstract void showChangePasswordDone(String nick);
    /**Called when a user requests to change its password.
     * @param nick the user nickname.
     */
    public abstract void showChangePasswordRequest(String nick);
    
    /**Called when a user deletion is requested.
     * @param nick the user nickname.
     */
    public abstract void showDeleteUserRequest(String nick);
    /**Called when a user deletion is done.
     * @param nick the user nickname.
     */
    public abstract void showDeleteUserDone(String nick);
    
    /**Called when a port test has been requested.
     * @param port the port to test.
     * @param hostAddress the host address.
     */
    public abstract void showTestPortsRequest(int port, String hostAddress);
    /**Called when a port test failed.
     * @param port the tested port.
     * @param hostAddress the tested host address.
     */
    public abstract void showTestPortsFailed(int port, String hostAddress);
    /**Called when a port test was successful.
     * @param port the tested port.
     * @param hostAddress the tested host address.
     */
    public abstract void showTestPortsDone(int port, String hostAddress);
    
    /**Called when somebody asked if a user (listNick) accepts messages by another user (nick2).
     * @param listNick the user whose incoming list must be checked.
     * @param nick2 the user that must be checked.
     */
    public abstract void showInListOfUserContainsRequest(String listNick, String nick2);
    /**Called when somebody asked if a user (listNick) accepts messages by another user (nick2) and the request was done.
     * @param listNick the user whose incoming list has been checked.
     * @param nick2 the user that has been checked.
     * @param contains true if listNick accepts messages by nick2, false otherwise.
     */
    public abstract void showInListOfUserContainsDone(String listNick, String nick2, boolean contains);
    
    /**Called when a moved user assignation has been requested.
     * @param nick the moving user nickname.
     */
    public abstract void showAssignMovedRequest(String nick);
    
    /**Called when a moved user assignation has been done.
     * @param nick the moving user nickname.
     */
    public abstract void showAssignMovedDone(String nick);
    
    /**Called when a user requested to delete its downloaded message queue.
     * @param nick the user nickname.
     */
    public abstract void showDeleteDownloadedRequest(String nick);
    
    /**Called when a user successfully deleted its downloaded message queue.
     * @param nick the user nickname.
     */
    public abstract void showDeleteDownloadedDone(String nick);
    
    /**Called when a load data has been sent.
     * @param sendingData the sent data.
     */
    public abstract void showSendLoad(String sendingData);
    /**
     * Called when a UDP Socked problem occurred while sending load data.
     */
    public abstract void showUDPSocketProblem();
    /**
     * Called when some problem occurred while trying to send load data.
     */
    public abstract void showSendLoadTransferProblem();
    
    /**
     * Called when a shutdown request failed because of the presence of currently managed users that must be moved to some other server.
     */
    public abstract void showShutDownFailedUsers();
    /**
     * Called when a shutdown request has been accepted.
     */
    public abstract void showShutdownDone();
	
	/**Called when a contact has successfully been removed by a contact list.
	 * @param nick the contact list owner.
	 * @param nick2 the removed nickname.
	 */
	public abstract void showRemoveContactDone(String nick, String nick2);
	/**Called when a user requested to remove a contact from its contact list.
	 * @param nick the contact list owner.
	 * @param nick2 the nickname to remove.
	 */
	public abstract void showRemoveContactRequest(String nick, String nick2);

	/**Called when a user successfully added a nickname to its blocking contact list.
	 * @param nick the blocking contact list owner.
	 * @param nick2 the blocked nickname.
	 */
	public abstract void showBlockContactDone(String nick, String nick2);
	/**Called when a user requested to add a nickname to its blocking contact list.
	 * @param nick the blocking contact list owner.
	 * @param nick2 the nickname of the user to block.
	 */
	public abstract void showBlockContactRequest(String nick, String nick2);

	/**Called when somebody successfully obtained a user's direct contact. 
	 * @param nick the user whose direct contact had been requested.
	 */
	public abstract void showGetContactDone(String nick);
	/**Called when a user's direct contact request has been forwarded by the cache. 
	 * @param nick the user whose direct contact had been requested.
	 */
	public abstract void showGetContactCache(String nick);
	/**Called when somebody asked a user's direct contact. 
	 * @param nick the user whose direct contact had been requested.
	 */
	public abstract void showGetContactRequest(String nick);
	
	/**Called when the direct contact of a user that is locally managed has been successfully sent.
	 * @param nick the user nickname.
	 */
	public abstract void showGetManagedContactDone(String nick);
	/**Called when the direct contact of a user that is locally managed failed because the user is not locally managed.
	 * @param nick the user nickname.
	 */
	public abstract void showGetManagedContactUserNotManaged(String nick);
	/**Called when the direct contact of a user that is locally managed has been requested.
	 * @param nick the user nickname.
	 */
	public abstract void showGetManagedContactRequest(String nick);
	
	
	/**Called when a backup for a user failed.
	 * @param nickname the user nickname.
	 */
	public void showCouldNotBackupUser(String nickname);
	/**Called when a user removal from the backup failed.
	 * @param nick the user nickname
	 */
	public void showCouldNotRemoveBackuppedUser(String nick);
	/**Called when a backup over a file started.
	 * @param filename the file the backup is being writed to.
	 */
	public void showBackupFileStart(String filename);
	/**Called when a backup procedure has been done.
	 */
	public void showBackupDone();
	/**Called when a backup procedure starts.
	 */
	public void showBackupStart();
	/**Called when a backup procedure failed.
	 */
	public void showBackupFailed();

    
    /**Called when a user got blocked.
     * @param nick the blocked user nickname.
     */
    public abstract void showUserBlocked(String nick);
    /**
     * Called when a shutdown has been requested.
     */
    public abstract void showShutdownRequest();
    /**
     * Called when the user assignation to this message server has been blocked.
     */
    public abstract void showAssignationBlocked();
    /**
     * Called when the user assignation to this message server has been unblocked.
     */
    public abstract void showAssignationUnblocked();
    /**
     * Called when a wrong administration password has been used to access some service.
     */
    public abstract void showAdminWrongPassword();
    /**Called when a request for a user that is not managed by this message server is done.
     * @param nick the user nickname
     */
    public abstract void showWrongUser(String nick);
    /**Called when a request with a wrong password for a user is done.
     * @param nick the user nickname
     */
    public abstract void showWrongUserPassword(String nick);
    /**Called when a user tried to add to its friend list another user that is already present. 
     * @param user the list owner.
     * @param userToAdd the user to add.
     */
    public abstract void showAddAlreadyInserted(String user, String userToAdd);
	/**Shows the user statistics.
	 * @param managedUsers the number of managed user
	 * @param onlineManagedUsers the number of online users
	 * @param users the formatted list of users and their status and direct contact.
	 */
	public abstract void showUsersStats(int managedUsers, int onlineManagedUsers, ManagedUser[] users);
	/**Shows the load statistics.
	 * @param currentStats the current Statistics object to print.
	 * @param bsHostName the bootstrap hostname.
	 * @param bsRmiPort the bootstrap rmi port.
	 * @param bsUdpPort the bootstrap udp port.
	 */
	public abstract void showLoadStats(Statistics currentStats, String bsHostName, int bsRmiPort, int bsUdpPort);
	
	/**Called when a gossip system error occured and a user exists but is not assigned to any server.
	 * @param user the user whose status is wrong.
	 */
	public abstract void showSystemError(User user);
	
	
	
	
}
