//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : HumanListener.java
//  @ Date : 19/03/2007
//  @ Author : 
//
//



package messageServerP;

import common.Statistics;



/**The human listener, a thread that waits the administration commands from the interface and performs the correspondent actions.
 * @author Marco Cornolti
 *
 */
public class HumanListener extends Thread {
    /**
     * The current human-user interface. Automatically set to textual when the thread starts.
     */
    public static HumanInterface currentInt=null;
    /* (non-Javadoc)
     * @see java.lang.Thread#run()
     */
    public void run() {
    	currentInt=new TextualInterfaceIt();
        currentInt.initialize();
        while (true){
            Command cmd = currentInt.getCommand();
            if (cmd.isPrintLoadStatistics()){
            	executePrintLoadStatistics();
            } else if (cmd.isChangeInterfaceToGUI()){
            	executeChangeInterfaceToGui();
            }  else if (cmd.isPrintUsersStatistics()){
            	executePrintUserStatistics();
            }  else if (cmd.isShutdown()){
            	executeShutdown();
            }  else if (cmd.isBackup()){
				executeBackup(cmd);
			}
        }
    }

    /**Shuts down the Message server if no users are assigned or returns false if there are
     * assigned users. If there are some assigned user, this method displays ad error message
     * in the current interface, else (if shutting down) a notifying message is displayed. 
     * @return false if there are assigned users, does not return otherwise.
     */
    protected static boolean executeShutdown(){
    	synchronized (ManagedUsersDatabase.class){
    		if (!ManagedUsersDatabase.noneAssigned()){
    			currentInt.showShutDownFailedUsers();
    			return false;
    		} else {
    			currentInt.showShutdownDone();
    			System.exit(0);
    			return true;
    		}

    	}
    }

    /**
     * Prints the user statistics.
     */
    private void executePrintUserStatistics(){
    	ManagedUser[] users = ManagedUsersDatabase.getManagedUsersArray();
    	currentInt.showUsersStats(ManagedUsersDatabase.getManagedUsers(), ManagedUsersDatabase.getOnlineManagedUsers(),users);
    }
    
    /**
     * NOT YET IMPLEMENTED: DOES NOTHING!
     * (should run the graphical interface)
     */
    private void executeChangeInterfaceToGui(){
    	//TODO: not yet implemented
    }

    /**
     * Prints the load statistics.
     */
    private void executePrintLoadStatistics(){
    	Statistics currentStats = new Statistics(Cache.getCacheEntries(),ManagedUsersDatabase.getManagedUsers(),ManagedUsersDatabase.getOnlineManagedUsers(),ManagedUsersDatabase.getQueuedMessagesNum());
    	currentInt.showLoadStats(currentStats, Cache.getBS().getIP().getCanonicalHostName(), Cache.getBS().getRMIPort(), Cache.getBS().getUDPPort());
    }
    
    /**Executes a complete backup in the file given as argument, or in the main backupper if the argument was not given.
     * @param com the command obtained by the human interface (contains the backup filename)
     */
    private void executeBackup(Command com) {
		String filename=com.getFilename();
		BackupperInterface fb;
		
		if (filename !=null && !filename.equals("")){
			fb = new FileBackupper(filename);
			currentInt.showBackupFileStart(filename);
		}
		else{
			fb=MessageServerCore.mainBackupper;
			currentInt.showBackupStart();
			synchronized (ManagedUsersDatabase.class){
				try{
					fb.backupWholeData(ManagedUsersDatabase.getManagedUsersList());
				} catch (Exception e){
					currentInt.showBackupFailed();
					return;
				}
			}
		}
		currentInt.showBackupDone();
	}
}

