package servlet;
import java.io.*;
import java.net.*;

import common.Message;

/**
 * This thread is permanently listening on the server socket.
 * When it receives a message, it analyses the different cases.
 * @author Alessandro Franchini
 *
 */
public class ClientListener extends Thread {
	ServerSocket ss = null;
	public void run(){
		try {
			ss = new ServerSocket(ClientCore.myself.getPort());
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		while(true){
			try {
				Socket so = ss.accept();
				InputStream is = so.getInputStream();
				ObjectInputStream dis = new ObjectInputStream(is);
				Object obj = dis.readObject();
				if(obj instanceof Message){
					Message mx = (Message) obj;
					if(GossipInterface.utenti.accepts(mx.getFrom())){
						if(mx.getText().equals("Type::Contact") || !GossipInterface.utenti.contains(mx.getFrom())){
							ConfirmInterface ci = new ConfirmInterface(mx.getFrom(),so);
							ci.setVisible(true);
						}
						else
							if(mx.getText().equals("Type::Offline")){
								GossipInterface.inLinea.removeElement(mx.getFrom().getNick());
								GossipInterface.offLinea.addElement(mx.getFrom().getNick());
								GossipInterface.onLine.repaint();
								GossipInterface.offLine.repaint();
								GossipInterface.utenti.setOnLine(mx.getFrom(),false);
								for(int i = 0; i<GossipInterface.conn.size();i++){
				            		if(mx.getFrom().equals(GossipInterface.conn.get(i).name)){
				            			GossipInterface.conn.get(i).pi.changeState(false);
				            		}
				            	}            
								so.close();
							}
							else
								if(mx.getText().equals("Type::Check")){
									OutputStream os = so.getOutputStream();
									DataOutputStream dos = new DataOutputStream(os);
									GossipInterface.utenti.setOnLine(mx.getFrom(),true);
									for(int i = 0; i<GossipInterface.conn.size();i++){
										if(mx.getFrom().equals(GossipInterface.conn.get(i).name)){
											GossipInterface.conn.get(i).pi.changeState(true);
										}
									}
									if(GossipInterface.utenti.getUser(mx.getFrom().getNick()).isFriend()){
										dos.writeBoolean(true);
										GossipInterface.inLinea.addElement(mx.getFrom().getNick());
										GossipInterface.offLinea.removeElement(mx.getFrom().getNick());
										GossipInterface.onLine.repaint();
										GossipInterface.offLine.repaint();
									}
									else
										dos.writeBoolean(false);
									so.close();
									
								}
								else
									if(GossipInterface.utenti.contains(mx.getFrom())){
										if(GossipInterface.utenti.getUser(mx.getFrom().getNick()).isFriend()){
											PeerCommunication tt = new PeerCommunication(so,GossipInterface.utenti.getUser(mx.getFrom().getNick()),mx);
											tt.start();
										}
									}
					}
					else{
						System.out.println("Non voglio ricevere messaggi da lui");
						if(!mx.getText().equals("")){
							OutputStream os = so.getOutputStream();
							DataOutputStream dos = new DataOutputStream(os);
							dos.writeBoolean(false);
						}
						so.close();
						
					}
				}
			} catch (IOException e) {
				System.out.println("The user exit");
				return;
			} catch (ClassNotFoundException e) {
				System.out.println("A problem occur");
				
			}
		}
	}

}
