package servlet;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import common.*;

/**
 * This graphic interface shows the login windows
 * @author Alessandro Franchini
 *
 */
public class LoginInterface extends JFrame {
	

	private static final long serialVersionUID = 1L;
	public JButton go;
	public JButton reg;
	final JPanel login;
	final JTextField username;
	public final JPasswordField pass;
	/**
	 * The constructor
	 *
	 */
	public LoginInterface(){
		setTitle("Login");
		setSize(430,170);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		login = new JPanel();
		login.setLayout(null);
		JLabel nick = new JLabel("Username");
		nick.setBounds(10,0,70,30);
		login.add(nick);
		username = new JTextField();
		username.setBounds(10,30,400,20);
		login.add(username);
		JLabel pwd = new JLabel("Password");
		pwd.setBounds(10,50,70,30);
		login.add(pwd);
		pass = new JPasswordField();
		pass.setBounds(10,80,400,20);
		login.add(pass);
		go = new JButton("Effettua il login");
		go.setMnemonic(KeyEvent.VK_E);
		go.setToolTipText("Effettua il login");
		go.setBounds(10,110,200,20);
		getRootPane().setDefaultButton(go);
		login.add(go);
		reg = new JButton("Registra nuovo utente");
		reg.setMnemonic(KeyEvent.VK_R);
		reg.setToolTipText("Registra nuovo utente");
		reg.setBounds(210,110,200,20);
		login.add(reg);
		getContentPane().add(login);
		setupEventi();
	}
	
	/**
	 * This method manages the events joined to the graphic interface.
	 *
	 */
	void setupEventi(){
		go.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				String name;
				if((name = username.getText()).length()==0){
					JOptionPane.showMessageDialog(login,"Insert the username","Gossip",JOptionPane.ERROR_MESSAGE);
					return;
				}
				if((ClientCore.pwd = new String(pass.getPassword())).length()==0){
					JOptionPane.showMessageDialog(login,"Insert the password","Gossip",JOptionPane.ERROR_MESSAGE);
					return;
				}
				ClientCore.myself.setName(name);
				MessageServer myMs = AccessOperation.askMsgServer(ClientCore.myself);
				if(myMs == null){
					username.setText("");
					pass.setText("");
					return;
				}
				ClientCore.ms = myMs;
				ContactList list = AccessOperation.logMsg(ClientCore.myself,ClientCore.pwd, myMs);
				if(list == null){
					username.setText("");
					pass.setText("");
					return;
				}
				Vector <Message> msg = AccessOperation.getMail(ClientCore.myself, ClientCore.pwd, myMs);
				if(msg == null){
					username.setText("");
					pass.setText("");
					return;
				}
				Vector <Message> temp = new Vector<Message>();
				int size = msg.size();
				for(int i = 0; i< size; i++){
					if(msg.get(i).getText().contains("Type::Contact")){
						temp.addElement(msg.get(i));
						msg.removeElementAt(i);
					}
				}
				GossipInterface.li.dispose();
				ClientCore.gi.dispose();
				GossipInterface gi = new GossipInterface(ClientCore.myself, list, msg);
				gi.setVisible(true);
				ClientCore.gi = gi;
				if(msg.size()!=0){
					MailInterface mi = new MailInterface(msg);
					mi.setVisible(true);
				}
				if(temp.size()!=0)
					for(int j = 0; j< temp.size(); j++){
						ConfirmInterface ci = new ConfirmInterface (temp.get(j).getFrom(),null);
						ci.setVisible(true);
					}
			};
		
		});
		reg.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				String user, pwd;
				if((user = username.getText()).length()==0){
					JOptionPane.showMessageDialog(login,"Insert the username","Gossip",JOptionPane.ERROR_MESSAGE);
					return;
				}
				User temp = ClientCore.myself;
				temp.setName(user);
				pwd = new String(pass.getPassword());
				if(pwd.length()==0){
					JOptionPane.showMessageDialog(login,"Insert the password","Gossip",JOptionPane.ERROR_MESSAGE);
					return;
				}
				boolean check = AccessOperation.register(temp, pwd);
				if(check)
					JOptionPane.showMessageDialog(login, "Registration done", "Gossip", JOptionPane.INFORMATION_MESSAGE);
				username.setText("");
				pass.setText("");				
			};
		});
	}
}


