package testing;

import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

import common.User;
import common.interfaces.BSForServletInterface;
import common.interfaces.exceptions.AssignationNotAcceptedException;
import common.interfaces.exceptions.BlockedException;
import common.interfaces.exceptions.GenericErrorException;
import common.interfaces.exceptions.UserNotExistsException;
import common.interfaces.exceptions.WrongPasswordException;

public class RegisterCancelTest {
	public static void main (String[] args) throws Exception{

		BSForServletInterface bsInt = null;
		try {
			bsInt = (BSForServletInterface) Naming.lookup("rmi://localhost:1111/gossipBS");
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotBoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		//Marco e' sul server 0
		bsInt.register("marco", "pallone");
		System.out.println("OK: aggiunta di utente inesistente consentita");

		try{
			bsInt.deleteUser(new User("antonio",null,0,true,true), "pallo");
			System.out.println("ERRORE: eliminazione di utente non esistente consentita");
		} catch(UserNotExistsException e){
			System.out.println("OK: eliminazione di utente non esistente non consentita");
		}

		try {
			bsInt.deleteUser(new User("marco",null,0,true,true), "pallo");
			System.out.println("ERRORE: eliminazione di utente con pw sbaglaita consentita");
				
		} catch (WrongPasswordException e) {
			System.out.println("OK: eliminazione di utente con pw sbaglaita non consentita");
		}
	
		
		bsInt.deleteUser(new User("marco",null,0,true,true), "pallone");
		System.out.println("OK: eliminazione con pw giusta consentita.");

		try{
			bsInt.deleteUser(new User("marco",null,0,true,true), "pallone");
			System.out.println("ERRORE: eliminazione utente inesistente consentita.");
		}catch (UserNotExistsException e){
			System.out.println("OK: eliminazione utente inesistente non consentita.");
		}
		
		bsInt.register("marco", "pallone");
		System.out.println("OK: aggiunta di utente cancellato e reiscritto consentita");
		

		
	}
}
